#include <windows.h>
#include "CMQObject.h"
#include "MergeMorphWindow.h"
#include "MergeMorph.h"

MergeMorphWindow::MergeMorphWindow(MQWindowBase& parent, MergeMorph *plugin) : MQDialog(parent), m_pPlugin(plugin)
{
	setlocale(LC_CTYPE, "");
	SetTitle(L"MergeMorph");

	MQFrame *mainFrame = CreateVerticalFrame(this);
	{
		std::string baseobjname = plugin->m_baseobj.getName();
		{
			MQFrame *frame0 = CreateHorizontalFrame(mainFrame);
			frame0->SetHorzLayout(LAYOUT_FILL);
			MQLabel *label0 = CreateLabel(frame0, L"base:");
			MQEdit *basename = CreateEdit(frame0, cmq::towstring(baseobjname));
			basename->SetReadOnly(true);
			basename->SetHorzLayout(LAYOUT_FILL);
		}
		{
			MQFrame *frame1 = CreateHorizontalFrame(mainFrame);
			{
				MQFrame *frame1_1 = CreateVerticalFrame(frame1);
				m_list1 = CreateListBox(frame1_1);
				m_list1->SetVertLayout(LAYOUT_FILL);
				m_weight1 = CreateDoubleSpinBox(frame1_1);
				m_weight1->SetMin(-200.0);
				m_weight1->SetMax(200.0);
				m_weight1->SetIncrement(10.0);
				m_weight1->SetPosition(100.0);
			}
			{
				MQFrame *frame1_2 = CreateVerticalFrame(frame1);
				m_list2 = CreateListBox(frame1_2);
				m_list2->SetVertLayout(LAYOUT_FILL);
				m_weight2 = CreateDoubleSpinBox(frame1_2);
				m_weight2->SetMin(-200.0);
				m_weight2->SetMax(200.0);
				m_weight2->SetIncrement(10.0);
				m_weight2->SetPosition(100.0);
			}

			auto morphlist = plugin->getMorphlist();
			for (auto obj : morphlist) {
				auto wname = cmq::towstring(obj.getName());
				m_list1->AddItem(wname, obj.getUniqueID());
				m_list2->AddItem(wname, obj.getUniqueID());
			}
		}
		{
			MQFrame *frame2 = CreateHorizontalFrame(mainFrame);
			frame2->SetHorzLayout(LAYOUT_FILL);
			MQLabel *label = CreateLabel(frame2, L"new morph name");
			m_newmorph = CreateEdit(frame2);
			std::string newname = m_pPlugin->getNewMorphName(std::string("new"));
			m_newmorph->SetText(cmq::towstring(newname));
			m_newmorph->SetHorzLayout(LAYOUT_FILL);
		}
		{
			MQFrame *frame3 = CreateHorizontalFrame(mainFrame);
			frame3->SetHorzLayout(LAYOUT_FILL);
			MQButton *cancel = CreateButton(frame3, L"Cancel");
			cancel->SetCancel(true);
			cancel->SetModalResult(DIALOG_CANCEL);
			MQButton *ok = CreateButton(frame3, L"OK");
			ok->SetDefault(true);
			ok->SetModalResult(DIALOG_OK);
			cancel->SetFillBeforeRate(80.0);
		}
	}

}

MergeMorphWindow::~MergeMorphWindow()
{
}
